/*	
    Copyright 2004 Helder Acevedo

    This file is part of XBCD.

    XBCD is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    XBCD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "effdrv.h"
#include <math.h>


int ftoi(float f)
{
   int result;

#ifdef SUPPORT_64BIT
   result = (int) f;
#else
	_asm {
		fld f
		fistp result
		}
#endif
	return result;
}

double sine(double x)
{
	double result;

#ifdef SUPPORT_64BIT
	result = sin(x);
#else
	_asm {
		fld x
		fsin
		fstp result
		}
#endif
	return result;
}
/*
double cose(double x)
{
	double result;

	_asm {
		fld x
		fcos
		fstp result
		}

	return result;
}
*/
void WriteReport(int index, BYTE lVal, BYTE rVal)
{
	//Send a report to the device.

	DWORD	BytesWritten = 0;
	INT		Index =0;
	CHAR	OutputReport[5];   // 070813 y.k.
	ULONG	Result;
	HANDLE  DeviceHandle;
	TCHAR    tsz[32];

	BYTE   tmp_save = 0;

	//int   tmp;
	
	//----------------------------------------------------------

      if(lVal <= 30 )
         {
            lVal = rVal = 0;
	  }
      else if((lVal > 30 )&&(lVal <= 50))
         { 
	   if(((In_angle  <= 21)||(In_angle  > 234))||((In_angle > 106)&&(In_angle <= 149)))
	   	{
                 lVal = 1; rVal = 0;
	   	}
	   else if(((In_angle  > 21) &&(In_angle <= 42))||((In_angle > 85)&&(In_angle <= 106))||
	   	        ((In_angle > 149)&&(In_angle <= 170))||((In_angle > 213)&&(In_angle <= 234)))
	   	{
	   	   lVal = rVal = 1;
	   	}
	   else if(((In_angle  > 42)&&(In_angle  <= 85))||((In_angle > 170 )&&(In_angle <= 213)))
	   	{
	   	   lVal = 0; rVal = 1;
	   	}	
         }
      else if((lVal > 50 )&&(lVal <= 100)) 
         { 
	   if(((In_angle  <= 12)||(In_angle  > 243))||((In_angle > 115)&&(In_angle <= 136)))
	   	{
                 lVal = 2; rVal = 0;
	   	}
	   else if(((In_angle  > 51)&&(In_angle  <= 76))||((In_angle > 179 )&&(In_angle <= 204)))
	   	{
	   	   lVal = 0; rVal = 2;
	   	}
	   else if(((In_angle  > 12) &&(In_angle <= 25))||((In_angle > 102)&&(In_angle <= 115))||
	   	        ((In_angle > 136)&&(In_angle <= 153))||((In_angle > 230)&&(In_angle <= 243)))
	   	{
	   	   lVal = 2; rVal = 1;
	   	}
	   else if(((In_angle  > 25) &&(In_angle <= 38))||((In_angle > 89)&&(In_angle <= 102))||
	   	        ((In_angle > 153)&&(In_angle <= 166))||((In_angle > 217)&&(In_angle <= 230)))
	   	{
	   	   lVal = 2; rVal = 2;
	   	}
	   else if(((In_angle  > 38) &&(In_angle <= 51))||((In_angle > 76)&&(In_angle <= 89))||
	   	        ((In_angle > 166)&&(In_angle <= 179))||((In_angle > 204)&&(In_angle <= 217)))
	   	{
	   	   lVal = 1; rVal = 2;
	   	}	   
         }	
      else if((lVal > 100 )&&(lVal <= 150))
       { 
	   if(((In_angle  <= 8)||(In_angle  > 245))||((In_angle > 117)&&(In_angle <= 136)))
	   	{
                 lVal = 3; rVal = 0;
	   	}
	   else if(((In_angle  > 53)&&(In_angle  <= 72))||((In_angle > 181 )&&(In_angle <= 200)))
	   	{
	   	   lVal = 0; rVal = 3;
	   	}
	   else if(((In_angle  > 8) &&(In_angle <= 17))||((In_angle > 108)&&(In_angle <= 117))||
	   	        ((In_angle > 136)&&(In_angle <= 145))||((In_angle > 236)&&(In_angle <= 245)))
	   	{
	   	   lVal = 3; rVal = 1;
	   	}
	   else if(((In_angle  > 17) &&(In_angle <= 26))||((In_angle > 99)&&(In_angle <= 108))||
	   	        ((In_angle > 145)&&(In_angle <= 154))||((In_angle > 227)&&(In_angle <= 236)))
	   	{
	   	   lVal = 3; rVal = 2;
	   	}
	   else if(((In_angle  > 26) &&(In_angle <= 35))||((In_angle > 90)&&(In_angle <= 99))||
	   	        ((In_angle > 154)&&(In_angle <= 163))||((In_angle > 218)&&(In_angle <= 227)))
	   	{
	   	   lVal = 3; rVal = 3;
	   	}	
	   else if(((In_angle  > 35) &&(In_angle <= 44))||((In_angle > 81)&&(In_angle <= 90))||
	   	        ((In_angle > 163)&&(In_angle <= 172))||((In_angle > 209)&&(In_angle <= 218)))
	   	{
	   	   lVal = 2; rVal = 3;
	   	}	
	   else if(((In_angle  > 44) &&(In_angle <= 53))||((In_angle > 72)&&(In_angle <= 81))||
	   	        ((In_angle > 172)&&(In_angle <= 181))||((In_angle > 200)&&(In_angle <= 209)))
	   	{
	   	   lVal = 1; rVal = 3;
	   	}		
         }
      else if((lVal > 150 )&&(lVal <= 200))
       { 
	   if(((In_angle  <= 7)||(In_angle  > 248))||((In_angle > 120)&&(In_angle <= 135)))
	   	{
                 lVal = 4; rVal = 0;
	   	}
	   else if(((In_angle  > 56)&&(In_angle  <= 71))||((In_angle > 184 )&&(In_angle <= 199)))
	   	{
	   	   lVal = 0; rVal = 4;
	   	}
	   else if(((In_angle  > 7) &&(In_angle <= 14))||((In_angle > 113)&&(In_angle <= 120))||
	   	        ((In_angle > 135)&&(In_angle <= 142))||((In_angle > 241)&&(In_angle <= 248)))
	   	{
	   	   lVal = 4; rVal = 1;
	   	}
	   else if(((In_angle  > 14) &&(In_angle <= 21))||((In_angle > 106)&&(In_angle <= 113))||
	   	        ((In_angle > 142)&&(In_angle <= 149))||((In_angle > 234)&&(In_angle <= 241)))
	   	{
	   	   lVal = 4; rVal = 2;
	   	}
	   else if(((In_angle  > 21) &&(In_angle <= 28))||((In_angle > 99)&&(In_angle <= 106))||
	   	        ((In_angle > 149)&&(In_angle <= 156))||((In_angle > 227)&&(In_angle <= 234)))
	   	{
	   	   lVal = 4; rVal = 3;
	   	}
	   else if(((In_angle  > 28) &&(In_angle <= 35))||((In_angle > 92)&&(In_angle <= 99))||
	   	        ((In_angle > 156)&&(In_angle <= 163))||((In_angle > 220)&&(In_angle <= 227)))
	   	{
	   	   lVal = 4; rVal = 4;
	   	}	
	   else if(((In_angle  > 35) &&(In_angle <= 42))||((In_angle > 85)&&(In_angle <= 92))||
	   	        ((In_angle > 163)&&(In_angle <= 170))||((In_angle > 213)&&(In_angle <= 220)))
	   	{
	   	   lVal = 3; rVal = 4;
	   	}		   
	   else if(((In_angle  > 42) &&(In_angle <= 49))||((In_angle > 78)&&(In_angle <= 85))||
	   	        ((In_angle > 170)&&(In_angle <= 177))||((In_angle > 206)&&(In_angle <= 213)))
	   	{
	   	   lVal = 2; rVal = 4;
	   	}	
	   else if(((In_angle  > 49) &&(In_angle <= 56))||((In_angle > 71)&&(In_angle <= 78))||
	   	        ((In_angle > 177)&&(In_angle <= 184))||((In_angle > 199)&&(In_angle <= 206)))
	   	{
	   	   lVal = 1; rVal = 4;
	   	}		
         }
      else
      	{
	   if(((In_angle  <= 5)||(In_angle  > 248))||((In_angle > 120)&&(In_angle <= 133)))
	   	{
                 lVal = 5; rVal = 0;
	   	}
	   else if(((In_angle  > 56)&&(In_angle  <= 69))||((In_angle > 184 )&&(In_angle <= 197)))
	   	{
	   	   lVal = 0; rVal = 5;
	   	}
	   else if(((In_angle  > 5) &&(In_angle <= 11))||((In_angle > 115)&&(In_angle <= 120))||
	   	        ((In_angle > 133)&&(In_angle <= 139))||((In_angle > 243)&&(In_angle <= 248)))
	   	{
	   	   lVal = 5; rVal = 1;
	   	}
	   else if(((In_angle  > 11) &&(In_angle <= 17))||((In_angle > 109)&&(In_angle <= 115))||
	   	        ((In_angle > 139)&&(In_angle <= 145))||((In_angle > 237)&&(In_angle <= 243)))
	   	{
	   	   lVal = 5; rVal = 2;
	   	}
	   else if(((In_angle  > 17) &&(In_angle <= 22))||((In_angle > 103)&&(In_angle <= 109))||
	   	        ((In_angle > 145)&&(In_angle <= 150))||((In_angle > 231)&&(In_angle <= 237)))
	   	{
	   	   lVal = 5; rVal = 3;
	   	}
	   else if(((In_angle  > 22) &&(In_angle <= 28))||((In_angle > 98)&&(In_angle <= 103))||
	   	        ((In_angle > 150)&&(In_angle <= 156))||((In_angle > 226)&&(In_angle <= 231)))
	   	{
	   	   lVal = 5; rVal = 4;
	   	}	
	   else if(((In_angle  > 28) &&(In_angle <= 34))||((In_angle > 92)&&(In_angle <= 98))||
	   	        ((In_angle > 156)&&(In_angle <= 162))||((In_angle > 220)&&(In_angle <= 226)))
	   	{
	   	   lVal = 5; rVal = 5;
	   	}	
	   else if(((In_angle  > 34) &&(In_angle <= 39))||((In_angle > 86)&&(In_angle <= 92))||
	   	        ((In_angle > 162)&&(In_angle <= 167))||((In_angle > 214)&&(In_angle <= 220)))
	   	{
	   	   lVal = 4; rVal = 5;
	   	}		   
	   else if(((In_angle  > 39) &&(In_angle <= 45))||((In_angle > 81)&&(In_angle <= 96))||
	   	        ((In_angle > 167)&&(In_angle <= 173))||((In_angle > 209)&&(In_angle <= 214)))
	   	{
	   	   lVal = 3; rVal = 5;
	   	}		   
	   else if(((In_angle  > 45) &&(In_angle <= 51))||((In_angle > 75)&&(In_angle <= 81))||
	   	        ((In_angle > 173)&&(In_angle <= 179))||((In_angle > 203)&&(In_angle <= 209)))
	   	{
	   	   lVal = 2; rVal = 5;
	   	}	
	   else if(((In_angle  > 51) &&(In_angle <= 56))||((In_angle > 69)&&(In_angle <= 75))||
	   	        ((In_angle > 179)&&(In_angle <= 184))||((In_angle > 197)&&(In_angle <= 203)))
	   	{
	   	   lVal = 1; rVal = 5;
	   	}	
      	}

//===============================================================//

	//The first byte is the report number.
	OutputReport[0]= 0;              // 070813 y.k.
	OutputReport[1]= 0;
	OutputReport[2]= 0;	
	OutputReport[3]= lVal;
	OutputReport[4]= rVal;
 	wsprintf(tsz, TEXT("=== check_commd = %d ==="), check_commd);  DebugPrint(tsz);

	if((check_commd >= 1)&&(check_commd <= 3))   
	{
	   DebugPrint("CP In === 0x01 0x02 0x01 0x01 ===");
	   OutputReport[0]= 0;              // 070813 y.k.
	   OutputReport[1]= 0x01;
	   OutputReport[2]= 0x02;	
	   OutputReport[3]= 0x01;
	   OutputReport[4]= 0x01;
     }
	if((check_commd >= 6)&&(check_commd <= 8))   
	{
	   DebugPrint("CP Out === 0x01 0x02 0x01 0x00 ===");
	   OutputReport[0]= 0;              // 070813 y.k.
	   OutputReport[1]= 0x01;
	   OutputReport[2]= 0x02;	
	   OutputReport[3]= 0x01;
	   OutputReport[4]= 0x00;
     }	
	if((check_commd >= 11)&&(check_commd <= 13))   
	{
	   DebugPrint("M In === 0x01 0x02 0x02 0x01 ===");
	   OutputReport[0]= 0;              // 070813 y.k.
	   OutputReport[1]= 0x01;
	   OutputReport[2]= 0x02;	
	   OutputReport[3]= 0x02;
	   OutputReport[4]= 0x01;
     }	
	if((check_commd >= 16)&&(check_commd <= 18))   
	{
	   DebugPrint("M Out === 0x01 0x02 0x02 0x00 ===");
	   OutputReport[0]= 0;              // 070813 y.k.
	   OutputReport[1]= 0x01;
	   OutputReport[2]= 0x02;	
	   OutputReport[3]= 0x02;
	   OutputReport[4]= 0x00;
     }	

 	DebugPrint("================ WriteReport 1 ================");
	wsprintf(tsz, TEXT("index = %d, lVal = %d : rVal = %d"), index, lVal, rVal);
	DebugPrint(tsz);

	DeviceHandle = CreateFile((LPCTSTR)DevPaths->array[index],
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_READ | FILE_SHARE_WRITE,
					(LPSECURITY_ATTRIBUTES)NULL,
					OPEN_EXISTING,
					0,
					NULL);

/*=============================
WriteHandle[Index_count]=CreateFile 
	(detailData[Index_count]->DevicePath, 
	 GENERIC_WRITE, 
	 FILE_SHARE_READ|FILE_SHARE_WRITE, 
	(LPSECURITY_ATTRIBUTES)NULL,
	OPEN_EXISTING, 
	0, 
	NULL);
=============================*/

	DebugPrint((LPCTSTR)DevPaths->array[index]);

	wsprintf(tsz, TEXT("DeviceHandle = %d"), DeviceHandle);
	DebugPrint(tsz);

if(DeviceHandle != INVALID_HANDLE_VALUE)
{
	wsprintf(tsz, TEXT("WriteReport WriteFile"));   DebugPrint(tsz);
	
	Result = WriteFile 
		(DeviceHandle, 
		 OutputReport, 
		 sizeof(OutputReport), 
		 &BytesWritten, 
		 NULL);
	wsprintf(tsz, TEXT("WriteReport WriteFile End"));   DebugPrint(tsz);
}
else
{
      wsprintf(tsz, TEXT("WriteReport Result = 0"));   DebugPrint(tsz);
      Result = 0;
}
/*=============================
if (WriteHandle[index] != INVALID_HANDLE_VALUE)
 {
   Result = HidD_SetOutputReport
		  (WriteHandle[index],
		    OutputReport[index],
		    Capabilities[index].OutputReportByteLength);
 }
=============================*/
	
// BytesWritten = 5
//	wsprintf(tsz, TEXT("BytesWritten = %d"), BytesWritten);
//	DebugPrint(tsz);

	DebugPrint("WriteReport 2");

	if (Result == 0)
	{
		DebugPrint("WriteReport 3");
		CloseHandle(DeviceHandle);
	}
	else
	{
          if(((check_commd >= 1)&&(check_commd <= 3))||
	       ((check_commd >= 6)&&(check_commd <= 8))||
	       ((check_commd >= 11)&&(check_commd <= 13))||
	       ((check_commd >= 16)&&(check_commd <= 18)))
	       {
                 check_commd = check_commd + 1;
              }   
       DebugPrint("WriteReport OK");
	}
	
    DebugPrint("WriteReport End");   //   070813 debug
	CloseHandle(DeviceHandle);
}

DWORD WINAPI TimeProc(LPVOID lpParam)
{
	//Timer Function
	//Runs as long as there is an effect that needs to be played
      TCHAR tsz[32];

	LONG lMagnitudex;


	bTimerOn = TRUE;
	do
	{
		int iDevCount;
		int iEffectCount;
		BOOLEAN bKillTimer = TRUE;
		TCHAR tsz[32];

		DebugPrint("TimeProc 1");
		DebugPrint("TimeProc 2");

 
		
		for(iDevCount = 0; iDevCount < Effects->elements; iDevCount++)
		{
			BYTE LVal = 0;
			BYTE RVal = 0;
			BOOLEAN bHasEffect = FALSE;
			BOOLEAN bStopDevice = TRUE;

			Array tmpEffects = (Array)Effects->array[iDevCount];
			DebugPrint("TimeProc 3");
			wsprintf(tsz, TEXT("tmpEffects->elements = %d"), tmpEffects->elements);
	              DebugPrint(tsz);
	
			for(iEffectCount = 0; iEffectCount < tmpEffects->elements; iEffectCount++)
			{
				PHWEFFECT tmpEffect = (PHWEFFECT)tmpEffects->array[iEffectCount];
				DebugPrint("TimeProc 4");
				bHasEffect = TRUE;
			#ifdef FIX_DIRECT_INPUT_ISSUE
				if(tmpEffect->bPlay & 0x01)			
			#else
				if(tmpEffect->bPlay)
                     #endif					
				{
					DWORD dwCurrentTime;
					DebugPrint("TimeProc 5");
					bStopDevice = FALSE;
					dwCurrentTime = timeGetTime();
//			              wsprintf(tsz, TEXT("tmpEffect->effect.dwDuration = %d"),tmpEffect->effect.dwDuration); // EFFECT_CONSTANT = -1 ; pause = 1000000
//	                            DebugPrint(tsz);	
					if(((tmpEffect->dwStartTime + (tmpEffect->effect.dwDuration/1000)) > dwCurrentTime) || (tmpEffect->effect.dwDuration == INFINITE))
					{
						DebugPrint("TimeProc 6");
						switch(tmpEffect->dwType)
						{
						case EFFECT_CONSTANT:
							{
								DebugPrint("TimeProc 7 EFFECT_CONSTANT");
//								if(abs(tmpEffect->fconstant.lMagnitude) > LVal)
									LVal = abs(tmpEffect->fconstant.lMagnitude);

//								if(abs(tmpEffect->fconstant.lMagnitude) > RVal)
									RVal = abs(tmpEffect->fconstant.lMagnitude);


								      lMagnitudex = tmpEffect->fconstant.lMagnitude;

	                                                        wsprintf(tsz, TEXT("lMagnitude = %d"), LVal);
	                                                        DebugPrint(tsz);
								
                                                   //    if(( timeGetTime() - tmpEffect->dwStartTime) > 360)
                                                   //    	{
                                                   //         DebugPrint("yk....><|||");
							//	    tmpEffect->bPlay = FALSE;
                                                  //     	    LVal = RVal = 0;
                                                  //     	}
								break;
							}
					       case EFFECT_SINE:
							{
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_SINE");

								bVal2 = timeGetTime() - tmpEffect->dwStartTime;
								DebugPrint("TimeProc 7.01");
								bVal2 = bVal2/tmpEffect->fperiodic.dwPeriod;
								DebugPrint("TimeProc 7.02");
								bVal2 = 360000 * bVal2;
								DebugPrint("TimeProc 7.03");
								bVal2 = bVal2 * M_PI/180;
								DebugPrint("TimeProc 7.04");
								bVal2 = sine(bVal2);
								DebugPrint("TimeProc 7.05");
								bVal2 = tmpEffect->fperiodic.dwMagnitude * bVal2;

								DebugPrint("TimeProc 7.1");

								if(bVal2 > 0)
								{
									bVal2 = absd(bVal2);
									if(bVal2 > RVal)
									{
										RVal = ftoi(bVal2);
									}
								}
								else
								{
									bVal2 = absd(bVal2);
									if(bVal2 > LVal)
									{
										LVal = ftoi(bVal2);
									}
								}

								break;
							}
						case EFFECT_RAMP:
							{
								LONG diffForce;
								LONG diffTime;
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_RAMP");

								diffTime = tmpEffect->effect.dwDuration/1000;

								if(tmpEffect->framp.lEnd > tmpEffect->framp.lStart)
								{
									if(tmpEffect->framp.lStart < 0)
									{
										diffForce = abs(tmpEffect->framp.lEnd) + abs(tmpEffect->framp.lStart);
										bVal2 = diffForce * (timeGetTime() - tmpEffect->dwStartTime)/diffTime;
										if(bVal2 < abs(tmpEffect->framp.lStart))
										{
											bVal2 = abs(tmpEffect->framp.lStart) - bVal2;
											if(bVal2 > LVal)
												LVal = ftoi(bVal2);
										}
										else
										{
											bVal2 = bVal2 - abs(tmpEffect->framp.lStart);
											if(bVal2 > RVal)
												RVal = ftoi(bVal2);
										}
									}
									else
									{
										diffForce = abs(tmpEffect->framp.lEnd) - abs(tmpEffect->framp.lStart);
										bVal2 = diffForce * (timeGetTime() - tmpEffect->dwStartTime)/diffTime;

										bVal2 = bVal2 + abs(tmpEffect->framp.lStart);
										if(bVal2 > RVal)
											RVal = ftoi(bVal2);
									}
								}
								else
								{
									if(tmpEffect->framp.lEnd < tmpEffect->framp.lStart)
									{
										if(tmpEffect->framp.lStart < 0)
										{
											diffForce = abs(tmpEffect->framp.lStart) - abs(tmpEffect->framp.lEnd);
											bVal2 = diffForce * (timeGetTime() - tmpEffect->dwStartTime)/diffTime;

											bVal2 = abs(tmpEffect->framp.lStart) + bVal2;
											if(bVal2 > LVal)
													LVal = ftoi(bVal2);
										}
										else
										{
											diffForce = abs(tmpEffect->framp.lEnd) + abs(tmpEffect->framp.lStart);
											bVal2 = diffForce * (timeGetTime() - tmpEffect->dwStartTime)/diffTime;
											if(bVal2 < abs(tmpEffect->framp.lStart))
											{
												bVal2 = abs(tmpEffect->framp.lStart) - bVal2;
												if(bVal2 > RVal)
													RVal = ftoi(bVal2);
											}
											else
											{
												bVal2 = bVal2 - abs(tmpEffect->framp.lStart);
												if(bVal2 > LVal)
													LVal = ftoi(bVal2);
											}
										}
									}
									else
									{
										if(tmpEffect->framp.lStart < 0)
										{
											if(abs(tmpEffect->framp.lStart) > LVal)
												LVal = abs(tmpEffect->framp.lStart);
										}
										else
										{
											if(abs(tmpEffect->framp.lStart) > RVal)
												RVal = abs(tmpEffect->framp.lStart);
										}
									}
								}
								break;
							}
						case EFFECT_SQUARE:
							{
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_SQUARE");

								bVal2 = timeGetTime() - tmpEffect->dwStartTime;
								DebugPrint("TimeProc 7.01");
								bVal2 = 1000 * bVal2/tmpEffect->fperiodic.dwPeriod;
								DebugPrint("TimeProc 7.02");
								bVal2 = bVal2 - floor(bVal2);
								DebugPrint("TimeProc 7.03");
								if(bVal2 < 0.5)
								{
									if(tmpEffect->fperiodic.dwMagnitude > RVal)
										RVal = tmpEffect->fperiodic.dwMagnitude;
								}
								else
								{
									if(tmpEffect->fperiodic.dwMagnitude > LVal)
										LVal = tmpEffect->fperiodic.dwMagnitude;
								}
								break;
							}
						case EFFECT_TRIANGLE:
							{
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_TRIANGLE");

								bVal2 = timeGetTime() - tmpEffect->dwStartTime;
								DebugPrint("TimeProc 7.01");
								bVal2 = 1000 * bVal2/tmpEffect->fperiodic.dwPeriod;
								DebugPrint("TimeProc 7.02");
								bVal2 = bVal2 - floor(bVal2);
								DebugPrint("TimeProc 7.03");
								if(bVal2 < 0.5)
								{
									if(tmpEffect->fperiodic.dwMagnitude > RVal)
										RVal = tmpEffect->fperiodic.dwMagnitude;
								}
								else
								{
									if(tmpEffect->fperiodic.dwMagnitude > LVal)
										LVal = tmpEffect->fperiodic.dwMagnitude;
								}
								break;
							}
						case EFFECT_SAWTOOTHUP:
							{
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_SAWTOOTHUP");

								bVal2 = timeGetTime() - tmpEffect->dwStartTime;
								DebugPrint("TimeProc 7.01");
								bVal2 = 1000 * bVal2/tmpEffect->fperiodic.dwPeriod;
								DebugPrint("TimeProc 7.02");
								bVal2 = bVal2 - floor(bVal2);
								DebugPrint("TimeProc 7.03");
								if(bVal2 < 0.5)
								{
									if(tmpEffect->fperiodic.dwMagnitude > RVal)
										RVal = tmpEffect->fperiodic.dwMagnitude;
								}
								else
								{
									if(tmpEffect->fperiodic.dwMagnitude > LVal)
										LVal = tmpEffect->fperiodic.dwMagnitude;
								}
								break;
							}
						case EFFECT_SAWTOOTHDOWN:
							{
								double bVal2;
								DebugPrint("TimeProc 7 EFFECT_SAWTOOTHDOWN");

								bVal2 = timeGetTime() - tmpEffect->dwStartTime;
								DebugPrint("TimeProc 7.01");
								bVal2 = 1000 * bVal2/tmpEffect->fperiodic.dwPeriod;
								DebugPrint("TimeProc 7.02");
								bVal2 = bVal2 - floor(bVal2);
								DebugPrint("TimeProc 7.03");
								if(bVal2 < 0.5)
								{
									if(tmpEffect->fperiodic.dwMagnitude > RVal)
										RVal = tmpEffect->fperiodic.dwMagnitude;
								}
								else
								{
									if(tmpEffect->fperiodic.dwMagnitude > LVal)
										LVal = tmpEffect->fperiodic.dwMagnitude;
								}
								break;
							}
						case CONDITION_SPRING:
							{
								DebugPrint("CONDITION_SPRING");
								break;
							}

						case CONDITION_FRICTION:
							{
								DebugPrint("CONDITION_FRICTION");
								break;
							}

						case CONDITION_DAMPER:
							{
								DebugPrint("CONDITION_DAMPER");
								break;
							}

						case CONDITION_INERTIA:
							{
								DebugPrint("CONDITION_INERTIA");
								break;
							}
						}
					}
					else
					{
					#ifdef FIX_DIRECT_INPUT_ISSUE
						tmpEffect->bPlay &= 0xfe;					
					#else
						tmpEffect->bPlay = FALSE;
					#endif
					}
					DebugPrint("tmpEffect->bPlay = FALSE 5");
				}
			}
			
//sprintf(tsz, "bHasEffect = %d", bHasEffect);   // 070813 debug
DebugPrint(tsz); 	

			if(bHasEffect)
			{
				DebugPrint("TimeProc 8");
				if(bStopDevice || bStopAllDevices)
				{
					LastLVal->array[iDevCount] = 0;
					LastRVal->array[iDevCount] = 0;
					WriteReport(iDevCount, 0, 0);
//					bKillTimer = TRUE;  // 070813 y.k. test
//					DebugPrint("======================================");
//					DebugPrint("WriteReport(iDevCount, 0, 0);");
				}
				else
				{
					bKillTimer = FALSE;
 	
// [ 080314 -- T{Control Panel & Master / Slave Motion խPhqT
					if(((check_commd >= 1)&&(check_commd <= 3))||
					    ((check_commd >= 6)&&(check_commd <= 8))||
					    ((check_commd >= 11)&&(check_commd <= 13))||
					    ((check_commd >= 16)&&(check_commd <= 18)))//||
 
					    {
					       LastLVal->array[iDevCount] = 0;
					       LastRVal->array[iDevCount] = 11;
					       LVal = 11;
					       RVal = 0;
					    }  
// ] 080314 -- T{Control Panel & Master / Slave Motion խPhqT
					
					if((LVal != (BYTE)LastLVal->array[iDevCount]) || (RVal != (BYTE)LastRVal->array[iDevCount]))  // 080312
					{
						//sprintf(tsz, "A: LVal = %d, RVal = %d", LVal , RVal); DebugPrint(tsz);

						DebugPrint("TimeProc 9");
						sprintf(tsz, "iDevCount = %d", iDevCount);
						DebugPrint(tsz);
						LastLVal->array[iDevCount] = LVal;
						LastRVal->array[iDevCount] = RVal;
						sprintf(tsz, "B: LVal = %d, RVal = %d", (BYTE)LastLVal->array[iDevCount], (BYTE)LastRVal->array[iDevCount]);
						DebugPrint(tsz);
						DebugPrint("Sending");
						WriteReport(iDevCount, LVal, RVal);
//                                          bKillTimer = TRUE;  // 070813 y.k. test
						sprintf(tsz, "bTimerOn = %d", bTimerOn);   // 070813 y.k. debug
						DebugPrint(tsz);   						  // 070813 y.k. debug
					}
				}
			}
		}
 
 
          if(((check_commd > 3 )&&(check_commd < 6))||
	       ((check_commd > 8)&&(check_commd < 11))||
	       ((check_commd > 13)&&(check_commd < 16))||
	       (check_commd > 18))//&&(check_commd < 21))||
 
	       {
                  check_commd = 0;
              } 	
 
		DebugPrint("TimeProc 10");

		if(bKillTimer)
		{
			DebugPrint("TimeProc : Finished");
			bTimerOn = FALSE;
		}
		
		//Allow 10 milliseconds between executions of the loop
		//Let the system do some other work
		Sleep(10);
		sprintf(tsz, "TT bTimerOn = %d", bTimerOn);   // 070813 y.k. debug
		DebugPrint(tsz); 	
	}
	while(bTimerOn);


DebugPrint("================= TimeProc End ================="); 	

	return 0;
}

double absd(double x)
{
	if(x < 0)
		x = x * -1;
	return x;
}
